unit Knobs2013_design;

{

   COPYRIGHT 2014 .. 20120 Blue Hell / Jan Punter

  Some parts are copyright :

     Author  : Neugls.
     Website : Http://www.neugls.info
     Email   : NeuglsWorkStudio@gmail.com

   these are marked with (*Neugls*)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 2 as
  published by the Free Software Foundation;

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  For all listed email addresses :

    _dot. to be substituted by a dot      '.'
    2@t2  to be substituted by an at sign '@'


  Blue Hell is a trade mark owned by

    Jan Punter
    https://www.bluehell.nl/
    jan2@t2mail_dot_bluehell_dot_nl
}

interface

uses

  System.Classes, KnobsConversions,

  // NOTE: When Delphi complains about DesignIntf and DesignEditors ...
  // add -LUDesignIDE to Program Options (Alt P / O) Delphi Compiler / Compiling / Additional options to pass to the
  // compiler. These units are used to add a property selector for the ControlType property on knobs, see
  // TKnobsConverterProperty


  DesignIntf, DesignEditors;

  procedure Register;

implementation

uses

  knobs2013, KnobsWorms;

type

  TKnobsConverterProperty = class( TStringProperty)
  // Property value selector for ControlType property of Knobs
  public
    function    GetAttributes: TPropertyAttributes;                   override;
    procedure   GetValues( Proc: TGetStrProc);                        override;
  end;


{ ========
  TKnobsConverterEditor = class( TStringProperty)
  // Property value selector for ControlType property of Knobs
  public
}

    function    TKnobsConverterProperty.GetAttributes: TPropertyAttributes; // override;
    begin
      Result := inherited + [ paValueList, paSortList];
    end;

    procedure   TKnobsConverterProperty.GetValues( Proc: TGetStrProc); // override;
    var
      i : Integer;
    begin
      with Converters
      do begin
        for i := 0 to Count - 1
        do Proc( Strings[ i]);
      end;
    end;





  procedure Register;
  begin
    RegisterComponents(
      'Knobs2013',
      [
        TKnobsData              , TKnobsStringData        , TKnobsLed               , TKnobsSelector          ,
        TKnobsKnob              , TKnobsSmallKnob         , TKnobsNoKnob            , TKnobsNoKnobVertical    ,
        TKnobsSlider            , TKnobsHSlider           , TKnobsPad               , TKnobsValuedButton      ,
        TKnobsValuedButtons     , TKnobsDisplay           , TKnobsFileSelector      , TKnobsIndicator         ,
        TKnobsIndicatorBar      , TKnobsIndicatorText     , TKnobsDataViewer        , TKnobsInput             ,
        TKnobsOutput            , TKnobsTextLabel         , TKnobsEditLabel         , TKnobsBox               ,
        TKnobsWirePanel         , TKnobsModule            , TKnobsModuleSelector    , TKnobsWorm              ,
        TKnobsWormPanel         , TKnobsDataMaker         , TKnobsGridControl       , TKnobsAutomationGrid    ,
        TKnobsTimerSpeedButton  , TKnobsDelayedSpeedButton, TKnobsMazeGraphViewer   , TKnobsSelectorChoice    ,
        TKnobsLightningViewer   , TKnobsPendulumViewer
      ]
    );
    RegisterPropertyEditor( TypeInfo( string), TKnobsValuedControl, 'ControlType', TKnobsConverterProperty);
    RegisterPropertyEditor( TypeInfo( string), TKnobsXYControl    , 'ControlType', TKnobsConverterProperty);
  end;



end.

